Index: /orxonox/branches/movie_player/src/story_entities/world.cc
===================================================================
--- /orxonox/branches/movie_player/src/story_entities/world.cc	(revision 4216)
+++ /orxonox/branches/movie_player/src/story_entities/world.cc	(revision 4217)
@@ -40,4 +40,5 @@
 #include "garbage_collector.h"
 #include "animation_player.h"
+#include "particle_engine.h"
 
 #include "command_node.h"
@@ -121,5 +122,5 @@
 {
   this->constuctorInit("", -1);
-
+  this->path = NULL;
   const char *string;
   char *name;
@@ -169,4 +170,5 @@
 World::World (char* name)
 {
+  this->path = NULL;
   this->constuctorInit(name, -1);
   //NullParent* np = NullParent::getInstance();
@@ -179,4 +181,5 @@
 World::World (int worldID)
 {
+  this->path = NULL;
   this->constuctorInit(NULL, worldID);
 }
@@ -195,8 +198,4 @@
   cn->reset();
 
-  ResourceManager::getInstance()->debug();
-  ResourceManager::getInstance()->unloadAllByPriority(RP_LEVEL);
-  ResourceManager::getInstance()->debug();
-
   delete WorldInterface::getInstance();
 
@@ -205,12 +204,12 @@
   delete this->lightMan;
   delete this->trackManager;
+  delete this->particleEngine;
   TextEngine::getInstance()->flush();
 
-  AnimationPlayer::getInstance()->debug();
   delete AnimationPlayer::getInstance(); // this should be at the end of the unloading sequence.
   //delete garbagecollecor
   //delete animator
 
-
+  ResourceManager::getInstance()->unloadAllByPriority(RP_LEVEL);
 }
 
@@ -249,4 +248,5 @@
   this->garbageCollector = GarbageCollector::getInstance();
 
+  this->particleEngine = ParticleEngine::getInstance();
   this->trackManager = TrackManager::getInstance();
   this->lightMan = LightManager::getInstance();
@@ -256,4 +256,6 @@
   AnimationPlayer::getInstance(); // initializes the animationPlayer
 
+  this->localCamera = new Camera();
+  this->localCamera->setName ("camera");
 }
 
@@ -264,11 +266,11 @@
 ErrorMessage World::load()
 {	
-  PRINTF0("> Loading world: '%s'\n", getPath());
-  
+  PRINTF(3)("> Loading world: '%s'\n", getPath());
+  TiXmlElement* element;
   GameLoader* loader = GameLoader::getInstance();
   
   if( getPath() == NULL)
     {
-      PRINTF0("World has no path specified for loading");
+      PRINTF(1)("World has no path specified for loading");
       return (ErrorMessage){213,"Path not specified","World::load()"};
     }
@@ -276,10 +278,8 @@
   TiXmlDocument* XMLDoc = new TiXmlDocument( path);
   // load the campaign document
-  if( !XMLDoc->LoadFile())
-    //this->glmis->step();
-  
+  if( !XMLDoc->LoadFile())  
   {
     // report an error
-    PRINTF0("Error loading XML File: %s @ %d:%d\n", XMLDoc->ErrorDesc(), XMLDoc->ErrorRow(), XMLDoc->ErrorCol());
+    PRINTF(1)("loading XML File: %s @ %d:%d\n", XMLDoc->ErrorDesc(), XMLDoc->ErrorRow(), XMLDoc->ErrorCol());
     delete XMLDoc;
     return (ErrorMessage){213,"XML File parsing error","World::load()"};
@@ -293,5 +293,5 @@
     {
       // report an error
-      PRINTF0("Specified XML File is not an orxonox world data file (WorldDataFile element missing)\n");
+      PRINTF(1)("Specified XML File is not an orxonox world data file (WorldDataFile element missing)\n");
       delete XMLDoc;
       return (ErrorMessage){213,"Path not a WorldDataFile","World::load()"};
@@ -304,5 +304,5 @@
   if( string == NULL)
     {
-      PRINTF0("World is missing a proper 'name'\n");
+      PRINTF(2)("World is missing a proper 'name'\n");
       string = "Unknown";
       temp = new char[strlen(string + 2)];
@@ -316,12 +316,28 @@
       this->worldName = temp;
     }
-  
-  
+  ////////////////
+  // LOADSCREEN //
+  ////////////////
+  element = root->FirstChildElement("LoadScreen");
+  if (element == NULL)
+    {
+      PRINTF(2)("no LoadScreen specified, loading default\n");
+
+      glmis->setBackgroundImage("pictures/load_screen.jpg");
+      this->glmis->setMaximum(8);
+      this->glmis->draw();
+    }
+  else
+    {
+      this->glmis->load(element);
+      this->glmis->draw();
+    }
+  this->glmis->draw();
   // find WorldEntities
-  TiXmlElement* element = root->FirstChildElement( "WorldEntities");
+  element = root->FirstChildElement("WorldEntities");
   
   if( element == NULL)
     {
-      PRINTF0("World is missing 'WorldEntities'\n");
+      PRINTF(1)("World is missing 'WorldEntities'\n");
     }
   else
@@ -329,5 +345,5 @@
       element = element->FirstChildElement();
       // load Players/Objects/Whatever
-      PRINTF0("Loading WorldEntities\n");
+      PRINTF(4)("Loading WorldEntities\n");
       while( element != NULL)
 	{
@@ -337,8 +353,9 @@
 	  //todo do this more elegant 
 	  if( element->Value() != NULL && !strcmp( element->Value(), "Player")) localPlayer = (Player*) created;
-	  if( element->Value() != NULL && !strcmp( element->Value(), "SkyBox")) skyBox = (SkyBox*) created;
+	  if( element->Value() != NULL && !strcmp( element->Value(), "SkyBox")) sky = (SkyBox*) created;
 	  element = element->NextSiblingElement();
+	  glmis->step(); //! \todo temporary
 	}
-      PRINTF0("Done loading WorldEntities\n");
+      PRINTF(4)("Done loading WorldEntities\n");
     }
   
@@ -360,21 +377,7 @@
   
   // free the XML data
+
   delete XMLDoc;
-  
-  // finalize world
-  // initialize Font
-//  testFont = new FontSet();
-//  testFont->buildFont("../data/pictures/font.tga");
-  
-  // create null parent
-  this->nullParent = NullParent::getInstance ();
-  this->nullParent->setName ("NullParent");
-  
-  // finalize myPlayer
-  if( localPlayer == NULL)
-    {
-      PRINTF0("No Player specified in World '%s'\n", this->worldName);
-      return (ErrorMessage){213,"No Player defined","World::load()"};
-    }
+  /* GENERIC LOADING PROCESS FINISHED */
   
   // bind input
@@ -383,6 +386,4 @@
   
   // bind camera
-  this->localCamera = new Camera();
-  this->localCamera->setName ("camera");
   //this->localCamera->bind (localPlayer);
   this->localPlayer->addChild (this->localCamera);
@@ -450,6 +451,4 @@
 
       
-  // LIGHT initialisation
-  lightMan = LightManager::getInstance();
   lightMan->setAmbientColor(.1,.1,.1);
   lightMan->addLight();
@@ -469,8 +468,10 @@
   tn->addChild(this->localCamera);
   localCamera->lookAt(tn);
+  localCamera->setMode(PNODE_MOVEMENT);
   this->localPlayer->setMode(PNODE_ALL);
   Vector* cameraOffset = new Vector (0, 5, -10);
   trackManager->condition(2, LEFTRIGHT, this->localPlayer);
   
+  this->sky->setParent(this->localCamera);
 
   // initialize debug coord system
@@ -482,8 +483,18 @@
   glEndList();
 
-  terrain = new Terrain("../data/worlds/newGround.obj");
+  terrain = new Terrain("worlds/newGround.obj");
   terrain->setRelCoor(Vector(0,-10,0));
   this->spawn(terrain);
 
+
+  ParticleSystem* system = new ParticleSystem(1000, PARTICLE_SPRITE);
+  system->setLifeSpan(.5);
+  system->setConserve(.99);
+  system->setRadius(2, 0, 2, 0);
+
+  ParticleEmitter* emitter = new ParticleEmitter(Vector(-1, 0, 0), M_PI_4, 100, .05);
+  emitter->setParent(this->localPlayer);
+  
+  particleEngine->addConnection(emitter, system);
 }
 
@@ -541,13 +552,8 @@
 	this->glmis->step();
 
-	// Create SkySphere
-	//	    this->skySphere = new Skysphere("../data/pictures/sky-replace.jpg");
-	//	    this->skySphere->setName("SkySphere");
-	//	    this->localCamera->addChild(this->skySphere);
-	//	    this->spawn(this->skySphere);
-	skyBox = new SkyBox();
-	skyBox->setTexture("pictures/sky/skybox", "jpg");
-	skyBox->setParent(localCamera);
-	this->spawn(skyBox);
+	sky = new SkyBox();
+	//	(SkyBox*)(sky)->setTexture("pictures/sky/skybox", "jpg");
+	sky->setParent(localCamera);
+	this->spawn(sky);
 
 	/*monitor progress*/
@@ -610,7 +616,7 @@
 
 	// Create SkySphere
-	skySphere = new Skysphere("../data/pictures/sky-replace.jpg");
-	this->localPlayer->addChild(this->skySphere);
-	this->spawn(this->skySphere);
+	sky = new Skysphere("pictures/sky-replace.jpg");
+	this->localPlayer->addChild(this->sky);
+	this->spawn(this->sky);
 	Vector* es = new Vector (20, 0, 0);
 	Quaternion* qs = new Quaternion ();
@@ -655,9 +661,9 @@
 
 	// Create SkySphere
-	this->skySphere = new Skysphere("../data/pictures/sky-replace.jpg");
-	this->skySphere->setName("SkySphere");
-	this->spawn(this->skySphere);
-	this->localCamera->addChild(this->skySphere);
-	this->skySphere->setMode(PNODE_MOVEMENT);
+	this->sky = new Skysphere("pictures/sky-replace.jpg");
+	this->sky->setName("SkySphere");
+	this->spawn(this->sky);
+	this->localCamera->addChild(this->sky);
+	this->sky->setMode(PNODE_MOVEMENT);
 	/*monitor progress*/
 	this->glmis->step();
@@ -844,8 +850,8 @@
   
   //GLMenuImageScreen* 
-  this->glmis = GLMenuImageScreen::getInstance();
+  this->glmis = new GLMenuImageScreen();
   this->glmis->init();
   this->glmis->setMaximum(8);
-  this->glmis->draw();
+  //  this->glmis->draw();
  
   PRINTF(3)("World::displayLoadScreen - end\n"); 
@@ -861,6 +867,6 @@
   PRINTF(3)("World::releaseLoadScreen - start\n"); 
   this->glmis->setValue(this->glmis->getMaximum());
-  //SDL_Delay(500);
   PRINTF(3)("World::releaseLoadScreen - end\n"); 
+  delete this->glmis;
 }
 
@@ -952,4 +958,6 @@
 
   TextEngine::getInstance()->draw();
+  particleEngine->draw(this->dtS); //!< \todo should be dts like in the Trunk;
+
   lightMan->draw(); // must be at the end of the drawing procedure, otherwise Light cannot be handled as PNodes //
 }
@@ -1119,6 +1127,6 @@
       
       /* function to let all entities tick (iterate through list) */
-      float seconds = this->dt / 1000.0;      
-      this->gameTime += seconds;
+      this->dtS = (float)this->dt / 1000.0;      
+      this->gameTime += this->dtS;
       //entity = entities->enumerate(); 
       tIterator<WorldEntity>* iterator = this->entities->getIterator();
@@ -1126,5 +1134,5 @@
       while( entity != NULL) 
 	{ 
-	  entity->tick (seconds);
+	  entity->tick (this->dtS);
 	  entity = iterator->nextElement();
 	}
@@ -1134,7 +1142,8 @@
       this->trackManager->tick(this->dt);
       this->localCamera->tick(this->dt);
-      this->garbageCollector->tick(seconds);
-
-      AnimationPlayer::getInstance()->tick(seconds);
+      this->garbageCollector->tick(this->dtS);
+
+      AnimationPlayer::getInstance()->tick(this->dtS);
+      particleEngine->tick(this->dtS);
     }
   this->lastFrame = currentFrame;
@@ -1151,5 +1160,5 @@
 {
   this->garbageCollector->update();
-  this->nullParent->update (dt);
+  this->nullParent->update (this->dtS);
 }
 
@@ -1239,10 +1248,10 @@
 bool World::command(Command* cmd)
 {
-  if( !strcmp( cmd->cmd, "view0")) this->localCamera->setViewMode(VIEW_NORMAL);
-  else if( !strcmp( cmd->cmd, "view1")) this->localCamera->setViewMode(VIEW_BEHIND);
-  else if( !strcmp( cmd->cmd, "view2")) this->localCamera->setViewMode(VIEW_FRONT);
-  else if( !strcmp( cmd->cmd, "view3")) this->localCamera->setViewMode(VIEW_LEFT);
-  else if( !strcmp( cmd->cmd, "view4")) this->localCamera->setViewMode(VIEW_RIGHT);
-  else if( !strcmp( cmd->cmd, "view5")) this->localCamera->setViewMode(VIEW_TOP);
+  if( !strcmp( cmd->cmd, CONFIG_NAME_VIEW0)) this->localCamera->setViewMode(VIEW_NORMAL);
+  else if( !strcmp( cmd->cmd, CONFIG_NAME_VIEW1)) this->localCamera->setViewMode(VIEW_BEHIND);
+  else if( !strcmp( cmd->cmd, CONFIG_NAME_VIEW2)) this->localCamera->setViewMode(VIEW_FRONT);
+  else if( !strcmp( cmd->cmd, CONFIG_NAME_VIEW3)) this->localCamera->setViewMode(VIEW_LEFT);
+  else if( !strcmp( cmd->cmd, CONFIG_NAME_VIEW4)) this->localCamera->setViewMode(VIEW_RIGHT);
+  else if( !strcmp( cmd->cmd, CONFIG_NAME_VIEW5)) this->localCamera->setViewMode(VIEW_TOP);
 
   return false;
@@ -1251,6 +1260,16 @@
 void World::setPath( const char* name)
 {
-  this->path = new char[strlen(name)+1];
-  strcpy(this->path, name);
+  if (this->path)
+    delete this->path;
+  if (ResourceManager::isFile(name))
+  {
+    this->path = new char[strlen(name)+1];
+    strcpy(this->path, name);
+  }
+  else
+    {
+      this->path = new char[strlen(ResourceManager::getInstance()->getDataDir()) + strlen(name) +1];
+      sprintf(this->path, "%s%s", ResourceManager::getInstance()->getDataDir(), name);
+    }
 }
 
Index: /orxonox/branches/movie_player/src/story_entities/world.h
===================================================================
--- /orxonox/branches/movie_player/src/story_entities/world.h	(revision 4216)
+++ /orxonox/branches/movie_player/src/story_entities/world.h	(revision 4217)
@@ -19,7 +19,6 @@
 class PNode;
 class GLMenuImageScreen;
-class Skysphere;
-class SkyBox;
 class LightManager;
+class ParticleEngine;
 class Terrain;
 class GarbageCollector;
@@ -96,4 +95,5 @@
   Uint32 lastFrame;                   //!< last time of frame
   Uint32 dt;                          //!< time needed to calculate this frame
+  float dtS;                          //!< The time needed for caluculations in seconds
   double gameTime;                    //!< this is where the game time is saved
   bool bQuitOrxonox;                  //!< quit this application
@@ -109,7 +109,7 @@
   PNode* nullParent;                  //!< The zero-point, that everything has as its parent.
   TrackManager* trackManager;         //!< The reference of the TrackManager that handles the course through the Level.
+  ParticleEngine* particleEngine;     //!< The ParticleEngine of the World.
   Camera* localCamera;                //!< The current Camera
-  Skysphere* skySphere;               //!< The Environmental Heaven of orxonox \todo insert this to environment insted
-  SkyBox* skyBox;
+  WorldEntity* sky;                   //!< The Environmental Heaven of orxonox \todo insert this to environment insted
   LightManager* lightMan;             //!< The Lights of the Level
   Terrain* terrain;                   //!< The Terrain of the World.
Index: /orxonox/branches/movie_player/src/subprojects/benchmark.cc
===================================================================
--- /orxonox/branches/movie_player/src/subprojects/benchmark.cc	(revision 4217)
+++ /orxonox/branches/movie_player/src/subprojects/benchmark.cc	(revision 4217)
@@ -0,0 +1,472 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software Foundation,
+   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
+
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+   co-programmer: ...
+
+*/
+
+
+#if defined __linux__ 
+
+#include "list.h"
+#include "world_entity.h"
+#include "vector.h"
+#include "player.h"
+#include "base_object.h"
+
+#include <asm/msr.h>
+#include <linux/timex.h>
+
+
+#define LIST_MAX 1000
+#define VECTOR_MAX 1000000
+#define ITERATIONS 10000
+
+
+int startBenchmarks()
+{
+
+  printf("===========================================================\n");
+  printf("=                      BENCHMARKS                         =\n");
+  printf("===========================================================\n");
+  printf(" the author is not paying any attention to cacheing effects\n");
+  printf(" of the CPU.\n\n");
+  printf("[title]\t\t\t\t\t     [cycles]\t[loops]\n\n");
+  //  printf("------------------------------------------------------------\n\n");
+
+  // first measure the time overhead:
+  unsigned long ini, end, dt, tmp;
+  rdtscl(ini); rdtscl(end);
+  dt = end - ini;
+
+  int type = -1; 
+  /* type   -1 == all 
+     type    0 == framework
+     type    1 == vector
+     type    2 == quaternion
+     type    3 == lists
+  */
+  if(type == 0 || type == -1)
+    {
+      /* framework test*/
+      
+      printf("Generating Objects:\t\t\t\t\t%i\n", ITERATIONS);
+      /* ************WorldEntity class test************** */
+      WorldEntity* w = NULL;
+      int i = 0;
+      unsigned long mittel = 0;
+      
+      for(i = 0; i < ITERATIONS; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  WorldEntity* w = new WorldEntity();
+	  
+	  rdtscl(end);
+	  delete w;
+	  mittel += (end - ini - dt);
+	}
+      float mi = mittel / (float)ITERATIONS;
+      printf(" Generate a WorldEntity object:\t\t%11.2f\n", mi);
+      
+      /*
+	mittel = 0;
+	for(i = 0; i < ITERATIONS; ++i)
+	{
+	rdtscl(ini);
+	
+	WorldEntity* w = new Primitive(P_SPHERE);
+	
+	rdtscl(end);
+	delete w;
+	mittel += (end - ini - dt);
+	}
+	mi = mittel / (float)ITERATIONS;
+	printf(" Generate a Primitive  object:\t\t%11.2f\n", mi);
+      */
+
+      mittel = 0;
+      for(i = 0; i < ITERATIONS; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  Vector* v = new Vector();
+	  
+	  rdtscl(end);
+	  delete v;
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)ITERATIONS;
+      printf(" Generate a Vector object:\t\t%11.2f\n", mi);
+
+
+     mittel = 0;
+      for(i = 0; i < ITERATIONS; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  Quaternion* q = new Quaternion();
+	  
+	  rdtscl(end);
+	  delete q;
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)ITERATIONS;
+      printf(" Generate a Quaternion object:\t\t%11.2f\n", mi);
+
+
+
+
+      printf("\nCalling function inline &| virtual, \t\t\t%i\n", ITERATIONS);
+      mittel = 0;
+      w = new WorldEntity();
+      for(i = 0; i < ITERATIONS; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  w->tick(0.0f);
+
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	  }
+      //delete w;
+      mi = mittel / (float)ITERATIONS;
+      printf(" Virt funct tick() of WE: \t\t%11.2f\n", mi);
+
+
+      mittel = 0;
+      WorldEntity wo;
+      for(i = 0; i < ITERATIONS; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  wo.tick(0.0f);
+	   
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	  }
+      //delete w;
+      mi = mittel / (float)ITERATIONS;
+      printf(" Inl virt funct tick() of WE v2: \t%11.2f\n", mi);
+
+      
+      mittel = 0;
+      BaseObject* bo = new BaseObject();
+      for(i = 0; i < ITERATIONS; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  bo->isFinalized();
+	   
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	  }
+      //delete w;
+      mi = mittel / (float)ITERATIONS;
+      printf(" Inl funct BaseObject::isFinazlized(): \t%11.2f\n", mi);
+
+      
+      tList<WorldEntity>* list = new tList<WorldEntity>();
+
+      
+      /* ************Primitvie class test************** */
+      list = new tList<WorldEntity>();
+ 
+      
+      /*
+	mittel = 0;
+	w = new Primitive(P_SPHERE);
+	for(i = 0; i < ITERATIONS; ++i)
+	{
+	rdtscl(ini);
+	
+	w->tick(0.0f);
+	
+	rdtscl(end);
+	mittel += (end - ini - dt);
+	}
+	mi = mittel / (float)ITERATIONS;
+	printf(" Call function tick() of Prim:\t\t%11.2f\n", mi);
+      */
+      
+    }
+  
+  if(type == 1 || type == -1)
+    {
+      printf("\nDoing some simple vector operations: \t\t\t%i\n", VECTOR_MAX);
+      /* vector test */
+      Vector* a = new Vector(1.3, 5.3, 4.1);
+      Vector* b = new Vector(0.4, 2.5, 6.2);
+      Vector* c = new Vector();
+      
+      unsigned long mittel, ini, end;
+      float mi;
+      int i = 0;
+      // addition
+      mittel = 0;
+      for(i = 0; i < VECTOR_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  *c = *a + *b;
+	   
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)VECTOR_MAX;
+      printf(" Addition of two vectors:\t\t%11.2f\n", mi);
+      
+      // multiplikation
+
+      mittel = 0;
+      for(i = 0; i < VECTOR_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  *c = a->cross( *b);
+	   
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)VECTOR_MAX;
+      printf(" CrossMult of two vectors:\t\t%11.2f\n", mi);
+
+    }
+  if( type == 2 || type == -1)
+    {
+      /* quaternion test */
+      printf("\nDoing some simple quaternion operations: \t\t%i\n", VECTOR_MAX);
+      /* vector test */
+      Quaternion* a = new Quaternion();
+      Quaternion* b = new Quaternion();
+      Quaternion* c = new Quaternion();
+      
+      unsigned long mittel, ini, end;
+      float mi;
+      int i = 0;
+      // quaternion generieren mit spez konstruktor
+      mittel = 0;
+      Vector* qa = new Vector(4.6, 9.3, 0.4);
+      Vector* qb = new Vector(3.5, 6.1, 4.3);
+      for(i = 0; i < VECTOR_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  Quaternion* qu = new Quaternion(*qa, *qb);
+	  
+	  rdtscl(end);
+	  delete qu;
+	  mittel += (end - ini - dt);
+	}
+      delete a;
+      delete b;
+      mi = mittel / (float)VECTOR_MAX;
+      printf(" Gen. quatern. betw. two vectors:\t%11.2f\n", mi);
+      
+      
+      // multiplication
+      mittel = 0;
+      for(i = 0; i < VECTOR_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  *c = *a * *b;
+	  
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)VECTOR_MAX;
+      printf(" Multiplying two quat.(=rot): a * b\t%11.2f\n", mi);
+      
+      
+      
+      // rotating a vector by a quaternion
+      mittel = 0;
+      for(i = 0; i < VECTOR_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  *qa = a->apply(*qb);
+	  
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)VECTOR_MAX;
+      printf(" Rot a vec by a quat: q->apply(v)\t%11.2f\n", mi);
+      
+      
+      
+      // generate rotation matrix
+      mittel = 0;
+      float matrix[4][4];
+      for(i = 0; i < VECTOR_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  a->matrix(matrix);
+	  
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)VECTOR_MAX;
+      printf(" Generate rot matrix: q->matrix(m)\t%11.2f\n", mi);
+    }
+  if( type == 3 || type == -1)
+    {
+      /* list tests*/
+      printf("\nList operations tests: \t\t\t\t\t%i\n", LIST_MAX);
+      tList<char>* list = new tList<char>();
+      char* name;
+      
+      printf(" Adding[1..10] elements to list, found:\n");
+      list->add("1");
+      list->add("2");
+      list->add("3");
+      list->add("4");
+      list->add("5");
+      list->add("6");
+      list->add("7");
+      list->add("8");
+      list->add("9");
+      list->add("10");
+      
+      /*give list out */
+      tIterator<char>* iterator = list->getIterator();
+      name = iterator->nextElement();
+      printf("  List Elements: \t\t");
+      while( name != NULL)
+	{
+	  printf("%s,", name);
+	  name = iterator->nextElement();
+	}
+      delete iterator;
+      printf("\n");
+      
+      
+      /*removing some elements from the list*/
+      printf(" Removing elements [2,3,6,8,10], adding [11] now found:\n");
+      list->remove("2");
+      list->remove("3");
+      list->remove("6");
+      list->remove("8");
+      list->remove("10");
+      list->add("11");
+      /*give list out */
+      iterator = list->getIterator();
+      name = iterator->nextElement();
+      printf("  List Elements: \t\t");
+      while( name != NULL)
+	{
+	  printf("%s,", name);
+	  name = iterator->nextElement();
+	}
+      delete iterator;
+      printf("\n");
+      
+      delete list;
+      printf("\nChecking list performance:\t\t\t\t%i\n", LIST_MAX);
+      
+      tList<int>* plist = new tList<int>();
+      unsigned long mittel, ini, end;
+      float mi;
+      int i = 0;
+      mittel = 0;
+      for(i = 0; i < LIST_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  plist->add(&i);
+	  
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)LIST_MAX;
+      printf(" Adding reference to list:\t\t%11.2f\n", mi);
+      
+      mittel = 0;
+      for(i = 0; i < LIST_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  plist->remove(&i);
+	  
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)LIST_MAX;
+      printf(" Removing 1st reference from list:\t%11.2f\n", mi);
+      
+
+      printf("\nList operations tests: \t\t\t\t\t%i\n", LIST_MAX);
+      list = new tList<char>();
+      printf(" Adding[1..10] elements to list, found:\n");
+      list->add("1");
+      list->add("2");
+      list->add("3");
+      list->add("4");
+      list->add("5");
+      list->add("6");
+      list->add("7");
+      list->add("8");
+      list->add("9");
+      list->add("10");
+      
+      /*give list out */
+      iterator = list->getIterator();
+      name = iterator->nextElement();
+      printf("  List Elements: \t\t");
+      while( name != NULL)
+	{
+	  printf("%s,", name);
+	  name = iterator->nextElement();
+	}
+      delete iterator;
+      printf("\n");
+      
+      
+      int c = 0;
+      printf(" Going trough list with nextElement(el) func: ");
+      name = list->firstElement();
+      while(c < 20)
+	{
+	  printf("%s,", name);
+	  name = list->nextElement(name);
+	  c++;
+	}
+      printf("\n");
+      
+
+      
+    }
+  
+}
+
+#else
+
+#include "debug.h"
+
+int startBenchmarks()
+{
+  PRINTF(1)("Benchmark is not implemented in this system\n");
+}
+
+#endif
Index: /orxonox/branches/movie_player/src/subprojects/benchmark.h
===================================================================
--- /orxonox/branches/movie_player/src/subprojects/benchmark.h	(revision 4217)
+++ /orxonox/branches/movie_player/src/subprojects/benchmark.h	(revision 4217)
@@ -0,0 +1,13 @@
+/*! 
+    \file benchmark.h
+    \brief benchmark functions
+*/ 
+
+
+#ifndef _BENCHMARK_H
+#define _BENCHMARK_H
+
+int startBenchmarks(void);
+
+
+#endif /* _BENCHMARK_H */
Index: /orxonox/branches/movie_player/src/track_manager.cc
===================================================================
--- /orxonox/branches/movie_player/src/track_manager.cc	(revision 4216)
+++ /orxonox/branches/movie_player/src/track_manager.cc	(revision 4217)
@@ -396,4 +396,17 @@
   this->textAnimation->setInfinity(ANIM_INF_CONSTANT);
 }
+
+
+/**
+   \brief loads a trackElement from a TiXmlElement
+   \param root the TiXmlElement to load the Data from
+
+*/
+bool TrackManager::load( TiXmlElement* root)
+{
+
+}
+
+
 
 /**
Index: /orxonox/branches/movie_player/src/track_manager.h
===================================================================
--- /orxonox/branches/movie_player/src/track_manager.h	(revision 4216)
+++ /orxonox/branches/movie_player/src/track_manager.h	(revision 4217)
@@ -153,4 +153,6 @@
   static TrackManager* getInstance(void);
 
+  bool load(TiXmlElement* root);
+
   // Methods to change the Path (initialisation)
   void workOn(unsigned int trackID);
Index: /orxonox/branches/movie_player/src/util/resource_manager.cc
===================================================================
--- /orxonox/branches/movie_player/src/util/resource_manager.cc	(revision 4216)
+++ /orxonox/branches/movie_player/src/util/resource_manager.cc	(revision 4217)
@@ -99,4 +99,24 @@
       return false;
     }
+}
+
+/**
+   \brief checks for the DataDirectory, by looking if 
+   \param fileInside is inisde??
+*/
+bool ResourceManager::checkDataDir(const char* fileInside)
+{
+  bool retVal;
+  if (!isDir(this->dataDir))
+    {
+      PRINTF(1)("%s is not a directory\n", this->dataDir);
+      return false;
+    }
+  
+  char* testFile = new char[strlen(this->dataDir)+strlen(fileInside)+1];
+  sprintf(testFile, "%s%s", this->dataDir, fileInside);
+  retVal = isFile(testFile);
+  delete testFile;
+  return retVal;
 }
 
@@ -182,5 +202,5 @@
   // searching if the resource was loaded before.
   Resource* tmpResource = this->locateResourceByInfo(fileName, type, param1, param2,param3);
-  if (tmpResource) // if the resource was not loaded before.
+  if (tmpResource) // if the resource was loaded before.
     {
       PRINTF(4)("not loading cached resource %s\n", tmpResource->name);
@@ -201,7 +221,6 @@
 
       // creating the full name. (directoryName + FileName)
-      char* fullName = new char[strlen(dataDir)+strlen(fileName)+1];
-      sprintf(fullName, "%s%s", this->dataDir, fileName);
-      
+      char* fullName = new char[strlen(this->getDataDir())+strlen(fileName)+1];
+      sprintf(fullName, "%s%s", this->getDataDir(), fileName);
       // Checking for the type of resource \see ResourceType
       switch(type)
@@ -213,5 +232,5 @@
 	    tmpResource->modelSize = 1.0;
 
-	  if(isFile(fullName))
+	  if(ResourceManager::isFile(fullName))
 	    tmpResource->pointer = new OBJModel(fullName, tmpResource->modelSize);
 	  else
@@ -510,19 +529,23 @@
     }
 
-  stat(tmpDirName, &status);
-  if (status.st_mode & (S_IFDIR
+  if(!stat(tmpDirName, &status))
+    {
+      if (status.st_mode & (S_IFDIR
 #ifndef __WIN32__
-			| S_IFLNK
+			    | S_IFLNK
 #endif
-			))
-    {
-      delete tmpDirName;
-      return true;
-    }
-  else
-    {
-      delete tmpDirName;
-      return false;
-    }
+			    ))
+	{
+	  delete tmpDirName;
+	  return true;
+	}
+      else
+	{
+	  delete tmpDirName;
+	  return false;
+	}
+    }
+  else
+    return false;
 }
 
@@ -534,15 +557,107 @@
 bool ResourceManager::isFile(const char* fileName)
 {
+  char* tmpFileName = ResourceManager::homeDirCheck(fileName);
+  // actually checks the File
   struct stat status;
-  stat(fileName, &status);
-  if (status.st_mode & (S_IFREG 
+  if (!stat(tmpFileName, &status))
+    {
+      if (status.st_mode & (S_IFREG 
 #ifndef __WIN32__
-			| S_IFLNK
+			    | S_IFLNK
 #endif
-			))
-    return true;
-  else
-    return false;
-}
+			    ))
+	{
+	  delete tmpFileName;
+	  return true;
+	}
+      else
+	{
+	  delete tmpFileName;
+	  return false;
+	}
+    }
+  else 
+    {
+      delete tmpFileName;
+      return false;
+    }
+}
+
+/**
+   \brief touches a File on the disk (thereby creating it)
+   \param fileName The file to touch
+*/
+bool ResourceManager::touchFile(const char* fileName)
+{
+  char* tmpName = ResourceManager::homeDirCheck(fileName);
+
+  FILE* stream;
+  if( (stream = fopen (tmpName, "w")) == NULL)
+    {
+      PRINTF(1)("could not open %s fro writing\n", fileName);
+      return false;
+    }
+  fclose(stream);
+    
+  delete tmpName; 
+}
+
+/**
+   \brief deletes a File from disk
+   \param fileName the File to delete
+*/
+bool ResourceManager::deleteFile(const char* fileName)
+{
+  char* tmpName = ResourceManager::homeDirCheck(fileName);
+  unlink(tmpName);
+  delete tmpName;
+}
+
+/** 
+    \param fileName the Name of the file to check
+    \returns The name of the file, including the HomeDir
+    IMPORTANT: this has to be deleted from the outside
+*/
+char* ResourceManager::homeDirCheck(const char* name)
+{
+  char* retName;
+  if (!strncmp(name, "~/", 2))
+    {
+      char tmpFileName[500];
+#ifdef __WIN32__
+      strcpy(tmpFileName, getenv("USERPROFILE"));
+#else
+      strcpy(tmpFileName, getenv("HOME"));
+#endif
+      retName = new char[strlen(tmpFileName)+strlen(name)];
+      sprintf(retName, "%s%s", tmpFileName, name+1);
+    }
+  else
+    {
+      retName = new char[strlen(name)+1];
+      strcpy(retName, name);
+    }
+  return retName;
+}
+
+/** 
+    \param fileName the Name of the File to check
+    \returns The full name of the file, including the DataDir, and NULL if the file does not exist
+    IMPORTANT: this has to be deleted from the outside
+*/
+char* ResourceManager::getFullName(const char* fileName)
+{
+  char* retName = new char[strlen(ResourceManager::getInstance()->getDataDir())
+			   + strlen(fileName) + 1];
+  sprintf(retName, "%s%s", ResourceManager::getInstance()->getDataDir(), fileName);
+  if (ResourceManager::isFile(retName))
+    return retName;
+  else
+    {
+      delete retName;
+      return NULL;
+    }
+}
+
 
 /**
